<%--
%(C) COPYRIGHT International Business Machines Corp. 2013, All Rights Reserved
%US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%><%@ page language="java" contentType="text/html;charset=UTF-8" pageEncoding="UTF-8"
%><%@ page import="java.util.Arrays"
%><%@ page import="java.util.HashMap"
%><%@ page import="java.util.List"
%><%@ page import="java.util.Map"
%><%@ page import="com.emptoris.framework.sso.UserRegistry"
%><%@ page import="com.rivermine.app.gateway.GatewayProperties"
%><%@ page import="com.rivermine.ui.servlet.RequestContext"
%><%@ page import="com.rivermine.i18n.Message"
%><%@ page import="com.rivermine.util.CookieUtil"
%><%@ page import="com.rivermine.util.StringUtil"
%><%!
static List<Message> keys = Arrays.asList(new Message[] {
    Message.LOGOUT });
%><%
boolean isDialog = "true".equals(request.getParameter("dialog"));
boolean isError = "true".equals(request.getParameter("error"));
Cookie[] cookies = request.getCookies();
String contextPath = CookieUtil.getValidatedPath(request.getContextPath());
boolean isExternalAuth = false;
Cookie isExternalAuthCookie = CookieUtil.getCookieByName("isExternalAuth", cookies);
if (isExternalAuthCookie != null)
{
    isExternalAuth = "true".equalsIgnoreCase(isExternalAuthCookie.getValue());
}
String forwardUrl = null;
if (isError)
{
    forwardUrl = GatewayProperties.getSSMErrorURL();
}
else if (isExternalAuth)
{
    forwardUrl = GatewayProperties.getSSOLogoutURLForExternalAuth();
}
if (StringUtil.isEmptyString(forwardUrl))
{
    forwardUrl = "/emptoris/login.jsp";
}
if (isError)
{
    forwardUrl = CookieUtil.appendQueryParam(forwardUrl, "error", "true");
}
else if (isDialog || "true".equals(request.getParameter("timeout")))
{
    forwardUrl = CookieUtil.appendQueryParam(forwardUrl, "timeout", "true");
}
String lang = CookieUtil.processLanguage(request, response);
String[] suiteAppUrls = null;
Map<Message, String> resources = null;
RequestContext.createInstance(getServletContext(), getServletName(), request);
UserRegistry userRegistry = new UserRegistry();
try
{
    suiteAppUrls = userRegistry.getSuiteAppURLs();
    resources = userRegistry.getTranslations(keys, lang);
}
finally
{
    userRegistry.disposeApplicationInstance();
    RequestContext.clearInstance();
}
//System.err.println(" LOGOUT ==================== forwardUrl: " + forwardUrl);
%><!DOCTYPE HTML>
<HTML>
<HEAD>
<LINK rel="shortcut icon" type="image/icon" href="favicon.ico">
<SCRIPT type="text/javascript" src="js/jquery-1.8.3.min.js"></SCRIPT>
<SCRIPT>
var okay = true;
var debug = false;
var results = '';
var dialogs = [];
var handles = [];
var checks = 0;
function prepareForClosure(obj) {
    try {
        obj.onbeforeunload = null;
        obj.onunload = null;
    }
    catch (exc) {}
    try {
        $.each(obj.frames, function(i, frame) {
            prepareForClosure(frame.contentWindow);
        });
    }
    catch (exc) {}
}
function closeWindow(obj) {
    if (typeof obj.closed == 'undefined') {
        return;
    }
    if (obj.closed) {
        return;
    }
    prepareForClosure(obj);
    try {
        obj.close();
    }
    catch (exc) {}
}
function closeDialogs() {
    $.ajax({
        url: '/emptoris/list-dialogs.jsp',
        dataType: 'json',
        cache: false,
        success: function(data) {
            for (var i = 0; i < data.dialogs.length; i++) {
                var dialog = data.dialogs[i];
                if (dialog.name != window.name) {
                    dialogs[dialogs.length] = dialog.name;
                }
            }
            closeHandles();
        },
        error: function() {
            okay = false;
            results = 'Error retrieving list of open dialogs';
            closeSession0();
        }
    });
}
function closeHandles() {
    for (var i in dialogs) {
        var name = dialogs[i];
        try {
            var winHandle = window.open('', name);
            if (winHandle && !winHandle.closed) {
                handles[name] = winHandle;
                closeWindow(winHandle);
            }
        }
        catch (exc) {}
    }
    checkClosure();
}
function checkClosure() {
    var checkAgain = false;
    for (var name in handles) {
        try {
            var winHandle = handles[name];
            if (!winHandle.closed) {
                checkAgain = true;
                break;
            }
        }
        catch (exc) {}
    }
    if (checkAgain) {
        if (++checks < 10) {
            setTimeout("checkClosure()", 500);
            return;
        }
        okay = false;
        results = 'Took too long';
    }
    closeSession0();
}
<%
for (int i = 0; i < suiteAppUrls.length; i++)
{
    String url = suiteAppUrls[i];
%>function closeSession<%= i %>() {
    $.ajax({
        url: '<%= url %>/clear-session.jsp',
        cache: false,
        dataType: 'json',
        complete: function() {
            <%= (i == suiteAppUrls.length - 1) ? "logout();" : ("closeSession" + (i + 1) + "();") %>
        }
    });
}
<%
}
%>function logout() {
    $.ajax({
        url: '/emptoris/ibm_security_logout',
        cache: false,
        complete: function() {
            redirect();
        }
    });
}
function redirect() {
    if (debug && !okay) {
        alert(results);
    }
<%
if (isDialog)
{
%>    closeWindow(window.opener);
    window.close();
<%
}
else
{
%>    window.location = '<%= forwardUrl %>';
<%
}
%>}
</SCRIPT>
</HEAD>
<%
if (isDialog)
{
%><BODY onload="closeSession0()">
<div style="font-family:Arial, Tahoma, Verdana, sans-serif; font-size:20px; text-align:left;">
<%= resources.get(Message.LOGOUT) %>
</div>
<%
}
else
{
%><BODY onload="closeDialogs()">
<%
}
%></BODY>
</HTML>
