<%--
%(C) COPYRIGHT International Business Machines Corp. 2012, All Rights Reserved
%US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%><%@ page language="java" contentType="text/html;charset=UTF-8" pageEncoding="UTF-8"
%><%@ page import="java.util.Arrays"
%><%@ page import="java.util.HashMap"
%><%@ page import="java.util.List"
%><%@ page import="java.util.Map"
%><%@ page import="com.emptoris.framework.sso.UserRegistry"
%><%@ page import="com.rivermine.app.gateway.GatewayProperties"
%><%@ page import="com.rivermine.ui.servlet.RequestContext"
%><%@ page import="com.rivermine.i18n.Message"
%><%@ page import="com.rivermine.i18n.MessageVSM"
%><%@ page import="com.rivermine.util.CookieUtil"
%><%@ page import="com.rivermine.log.Logger"
%><%!
static List<Message> keys = Arrays.asList(new Message[] {
    MessageVSM.TOU_SCREEN_ACCEPT,
    MessageVSM.TOU_SCREEN_DECLINE,
    MessageVSM.TOU_SCREEN_HEADER
});
%><%
Logger s_log = Logger.getLogger("tou_prompt.jsp");
if (request.getUserPrincipal() == null)
{
    response.sendRedirect("/emptoris/login.jsp");
    return;
}
String username = request.getUserPrincipal().getName();
// CookieUtil.LOCALE_CODES are "en_US", "es_ES", "it_IT", "fr_FR", "de_DE", "pt_BR", "ja_JP", "zh_CN", "zh_TW", "ko_KR"
// CookieUtil.processLanguage can accept a third argument with an augmented array of localeCodes
// to getActiveTermsOfUserUrl (for Sourcing languages), but in this case getTranslations would default to English
String lang = CookieUtil.processLanguage(request, response);
String touUrl = "";
Map<Message, String> resources = null;
RequestContext.createInstance(getServletContext(), getServletName(), request);
UserRegistry userRegistry = new UserRegistry();
try
{
    touUrl = userRegistry.getActiveTermsOfUseUrl(username, lang);
    resources = userRegistry.getTranslations(keys, lang);
}
catch (Throwable t)
{
    s_log.error(t);
}
finally
{
    userRegistry.disposeApplicationInstance();
    RequestContext.clearInstance();
}
response.setHeader("Pragma", "no-cache");
response.setHeader("Cache-Control", "private, no-cache, no-store");
response.setDateHeader("Expires", 0);
%><!DOCTYPE HTML>
<HTML>
<HEAD>
<TITLE>IBM Emptoris Strategic Supply Management</TITLE>
<LINK rel="shortcut icon" type="image/icon" href="favicon.ico">
<LINK REL="stylesheet" HREF="css/oneui.min.css">
<META HTTP-EQUIV="Cache-Control" CONTENT="private, no-cache, no-store">
<META http-equiv="Content-Type" content="text/html; charset=UTF-8">
<SCRIPT>
function init() {
    if (document.all) { // IE only
        var lc = document.getElementById("LanguagesContainer");
        lc.style.fontSize="11px";
        var lg = lc.childNodes;
        for (var i = 0; i < lg.length; i++) {
            if (lg[i].style) {
                lg[i].style.fontSize="11px";
            }
        }
        var button = document.getElementById("dijit_form_Button_Accept").parentElement.parentElement;
        button.style.backgroundColor="#f4f4f4";
        button.style.border="1px solid #c3c3c3";
        button.style.boxShadow="0px 1px 0px rgba(0, 0, 0, 0.1)";
        if (document.documentMode < 9) {
            button.style.padding="3px 10px 5px";
        }
        button = document.getElementById("dijit_form_Button_Decline").parentElement.parentElement;
        button.style.backgroundColor="#f4f4f4";
        button.style.border="1px solid #c3c3c3";
        button.style.boxShadow="0px 1px 0px rgba(0, 0, 0, 0.1)";
        if (document.documentMode < 9) {
            button.style.padding="3px 10px 5px";
        }
        try {
            document.querySelector('div.blueLip').style.backgroundImage="-ms-linear-gradient(top, #1a96c6 0%, #0075a3 100%)";
        }
        catch (e) {}
    }
}
var focusedDiv = null;
var touContentFrame = null; 
function checkSubmit(event) {
    var e = event || window.event;
    if (e && e.keyCode == 13 && focusedDiv != null) {
        if (focusedDiv.id == "acceptButton")
        {
            acceptTOU('y');
        }
        else 
        {
            acceptTOU('n');
        }
        document.forms[0].submit()
   }
}
function sharpen(div) {
    div.style.opacity=1.0;
    div.style.filter="alpha(opacity=100)";
    focusedDiv = div;
}
function dim(div) {
    div.style.opacity=0.6;
    div.style.filter="alpha(opacity=60)";
    focusedDiv = null;
}
function acceptTOU(value) {
    document.getElementById("accepttou").value = value;
}
function setTOUContents(){
    loadFrame();
}
function loadFrame(){
    var iframe = document.getElementById("touframe");
    touContentFrame = iframe;
    if (document.all) {
        handle();
        iframe.onreadystatechange = function() {
            if (iframe.readyState == "complete" || iframe.readyState == "loaded") {
               handle();
            }
        };
    }
    else {
        iframe.onload = handle;
    }
    if (document.all && !document.addEventListener) {
       // alert('IE8');
       touContentFrame.style.height = "400px";
    }
    else
    {
        resizeTouContentFrame();
        window.onresize = resizeTouContentFrame; //Bind function to event, so whenever the window is resized, resize the current frame accordingly
    }
    iframe.src = "<%= touUrl %>";
}
function handle()
{

}

function getYCoord(elem) {
    return elem.offsetParent ? (elem.offsetTop + getYCoord(elem.offsetParent)) : elem.offsetTop;
}

function resizeTouContentFrame() {
    if(touContentFrame==null || touContentFrame==undefined){
        return;
    }

    var buffer = 120 ; // Buffer to always show Accept/Decline and language links & prevent the side scrollbar
 
    //Iframe height = get window height, and then subtract out the height of elements above the iframe (with a small buffer to prevent the side scrollbar from appearing)
    var height = window.innerHeight || document.body.clientHeight || document.documentElement.clientHeight;
    height -= getYCoord(touContentFrame) + buffer;
    height = (height < 0) ? 0 : height;
    touContentFrame.style.height = height + 'px';
}

</SCRIPT>
</HEAD>
<BODY class="oneui" onload="setTOUContents();init()"
    style="width:100%; height:100%; margin:0pt; padding:0pt; text-align:center; overflow:auto;font-family:verdana, arial, helvetica, sans-serif;font-size:10pt">
    <FORM NAME="login" METHOD="POST" ACTION="post_login.jsp" autocomplete="off">
    <div onKeyPress="return checkSubmit(event)">
        <div widgetid="header" id="header" class="headerContainer" style="text-align:left;">
            <div
                class="navThick secondLevelBlue secondLevelBlueSingleRow secondLevelSingleRow widthLiquid"
                dojoattachpoint="_mainContainerNode">
                <div class="nav">
                    <div class="navInner">
                        <ul>
                            <li><a href="#"><div class="productName">IBM<sup>®</sup>
                                Emptoris<sup>®</sup> Strategic Supply Management</div></a></li>
                            <li class="right end"><a href="javascript:"><div id="ibmLogoBox"
                                class="logoBox"><div class="ibmLogo" alt="IBM®"></div></div></a></li>
                        </ul>
                    </div>
                </div>
                <div class="blueLip"
                    style="filter:progid:DXImageTransform.Microsoft.gradient(startColorStr=#1a96c6, endColorStr=#0075a3)">
                    <!-- IE sets the height of an empty div to 15px (with this comment it is 4px) -->
                </div>
            </div>
        </div>
        <div widgetid="idx_app_LoginFrame_0" id="idx_app_LoginFrame_0" name="idx_app_LoginFrame_0"
            class="LoginFrame idxLoginFrame" lang="en">
            <div class="idxLoginBoxWithShadow" cellpadding="0" cellspacing="0" border="0">
                <div class="idxLoginBox" id="idxLoginBox"
                    style="width:800px; height:100%; margin-top:30px; margin-bottom:auto; margin-left:auto; margin-right:auto;">
                    <div class="idxLoginBoxInner" style="text-align:left; padding=0; margin=auto;">
                        <div class="idxLoginTitle"><%= resources.get(MessageVSM.TOU_SCREEN_HEADER) %></div>
                        <div class="idxFieldLabel" id="tou" style="margin:0;" >
                             <iframe class="idxFieldLabel" id="touframe" name="touframe"
                                 style="width:790px; height:100%; border:1px solid #c3c3c3" display:block></iframe>
                         </div>
                    </div>
                    <div dojoattachpoint="containerNode"></div>
                    <input type="hidden" id="accepttou" name="accepttou"/>
                    <div style="margin-top:20px; text-align:left;">
                        <!-- The IE alpha filter does not work unless the width is also specified -->
                        <span id="acceptButton" class="dijit dijitReset dijitInline dijitButton dijitButtonHover dijitHover"
                            style="cursor:default; width:40px; opacity:0.6; filter:alpha(opacity=60)"
                            onmouseover="sharpen(this)" onmouseout="dim(this)" onClick="acceptTOU('y');document.forms[0].submit()"
                            role="button" lang="en"><span class="dijitReset dijitInline dijitButtonNode"
                            onfocus="sharpen(this.parentNode)" onblur="dim(this.parentNode)"
                            role="button" TABINDEX="5"><span class="dijitReset dijitStretch dijitButtonContents"
                                id="dijit_form_Button_Accept" onClick="acceptTOU('y');document.forms[0].submit()"
                                aria-labelledby="dijit_form_Button_0_label"
                                data-dojo-attach-point="titleNode,focusNode"
                                style="-moz-user-select:none; white-space:nowrap"
                                role="button"><%= resources.get(MessageVSM.TOU_SCREEN_ACCEPT) %></span></span></span>
                        &nbsp;
                        <span id="declineButton" class="dijit dijitReset dijitInline dijitButton dijitButtonHover dijitHover"
                            style="cursor:default; width:40px; opacity:0.6; filter:alpha(opacity=60)"
                            onmouseover="sharpen(this)" onmouseout="dim(this)" onClick="acceptTOU('n');document.forms[0].submit()"
                            role="button" lang="en"><span class="dijitReset dijitInline dijitButtonNode"
                            onfocus="sharpen(this.parentNode)" onblur="dim(this.parentNode)"
                            role="button" TABINDEX="6"><span class="dijitReset dijitStretch dijitButtonContents"
                                id="dijit_form_Button_Decline" onClick="acceptTOU('n');document.forms[0].submit()"
                                aria-labelledby="dijit_form_Button_0_label"
                                data-dojo-attach-point="titleNode,focusNode"
                                style="-moz-user-select:none; white-space:nowrap"
                                role="button"><%= resources.get(MessageVSM.TOU_SCREEN_DECLINE) %></span></span></span>
                    </div>
                    <div id="LanguagesContainer"
                        style="font-family:serif; font-size:9pt; margin-top:20px; text-align:left;">
                        <a class="languagelist" href="#" TABINDEX="8"
                            onClick="window.location.href='tou_prompt.jsp?language=en_US';return false;">English</a>
                        <span class="pipe"> | </span>
                        <a class="languagelist" href="#" TABINDEX="9"
                            onClick="window.location.href='tou_prompt.jsp?language=es_ES';return false;">Español</a>
                        <span class="pipe"> | </span>
                        <a class="languagelist" href="#" TABINDEX="10"
                            onClick="window.location.href='tou_prompt.jsp?language=it_IT';return false;">Italiano</a>
                        <span class="pipe"> | </span>
                        <a class="languagelist" href="#" TABINDEX="11"
                            onClick="window.location.href='tou_prompt.jsp?language=fr_FR';return false;">Français</a>
                        <span class="pipe"> | </span>
                        <a class="languagelist" href="#" TABINDEX="12"
                            onClick="window.location.href='tou_prompt.jsp?language=de_DE';return false;">Deutsch</a>
                        <span class="pipe"> | </span>
                        <a class="languagelist" href="#" TABINDEX="13"
                            onClick="window.location.href='tou_prompt.jsp?language=pt_BR';return false;">Português</a>
                        <span class="pipe"> | </span>
                        <a class="languagelist" href="#" TABINDEX="14"
                            onClick="window.location.href='tou_prompt.jsp?language=ja_JP';return false;">日本語</a>
                        <span class="pipe"> | </span>
                        <a class="languagelist" href="#" TABINDEX="15"
                            onClick="window.location.href='tou_prompt.jsp?language=zh_CN';return false;">简体中文</a>
                        <span class="pipe"> | </span>
                        <a class="languagelist" href="#" TABINDEX="16"
                            onClick="window.location.href='tou_prompt.jsp?language=zh_TW';return false;">繁體中文</a>
                        <span class="pipe"> | </span>
                        <a class="languagelist" href="#" TABINDEX="17"
                            onClick="window.location.href='tou_prompt.jsp?language=ko_KR';return false;">한국어</a>
                     </div>
                  </div>
            </div>
        </div>
    </div>
    </FORM>
</BODY>
</HTML>
